// BDE - (C) Copyright 1995 by Borland International

// input.c
#include "snipit.h"

// Prototype the function pointers here.

void AddAlias(void);
void Aliases(void);
void BatchMove(void);
void BlobIO(void);
void Block(void);
void BookMark(void);
void Configuration(void);
void CreateAndFillSampleTXT(void);
void CreateAndFillSamplePX(void);
void CreateAndFillSampleDB(void);
void CreateAndFillInMemoryTbl(void);
void DatabaseIOSample(void);
void DriverCaps(void);
void ErrVal(void);
void FiltComp(void);
void FiltCont(void);
void Filter(void);
void Format(void);
void IndexDBase(void);
void IndexExpr(void);
void IndexPDox(void);
void InitEngSample(void);
void InputReqCallback(void);
void KeyUpdate(void);
void LangDriver(void);
void LiveSQL (void);
void LnkCrsr(void);
void LocalSQL(void);
void LoginCallback(void);
void Navigate(void);
void OptParam(void);
void ParadoxSort(void);
void Password(void);
void QBE(void);
void QBE2(void);
void Range(void);
void RdoLock(void);
void RecLock(void);
void RecordUpdate(void);
void RefInteg(void);
void SecDesc(void);
void SessionIO(void);
void SimpleBlobIO(void);
void SoftDel(void);
void SQLBind(void);
void SQLTran(void);
void StoredProcedures(void);
void SysInfo(void);
void LocalSQLJoin(void);
void TableList(void);
void TableOpen(void);
void TableSearch(void);
void TBFieldMap(void);
void TblInfo(void);
void TblLock(void);
void TBRestructureCallBack(void);
void TBRestructure(void);
void TextExport(void);
void TextImport(void);
void Test(void);
void UpdateCurrent(void);
void UpSize(void);
void ValCheck(void);

// Data for the code viewer.

VIEW_INPUT  far InputData[MAX_VIEW_CODE_MODULES] =
{   // Code Name                             FuncPtr               File Name
    // ID for Desc
      {"Field: Using simple BLOBs",          SimpleBlobIO,         "Blobsmpl.c",
       IDS_SIMPLE_BLOB_IO},
      {"Field: Using BLOBs",                 BlobIO,               "Blobio.c",
       IDS_BLOB_IO},
      {"Record: Block Operations",           Block,                "Block.c",
       IDS_BLOCK},
      {"Cursor: Using BookMarks",            BookMark,             "Bookmark.c",
       IDS_BOOKMARK},
      {"Environment: Alias (Info)",          Aliases,              "Aliases.c",
       IDS_ALIASES},
      {"Environment: Alias (Adding)",        AddAlias,             "AddAlias.c",
       IDS_ADDALIAS},
      {"Environment: Configuration info",    Configuration,        "Config.c",
       IDS_CONFIG},
      {"Index: dBASE",                       IndexDBase,           "Idxdbase.c",
       IDS_INDEX_DBASE},
      {"Index: Paradox",                     IndexPDox,            "Idxpdox.c",
       IDS_INDEX_PDOX},
      {"Index: dBASE Expression",            IndexExpr,            "Idxexpr.c",
       IDS_INDEX_EXPR},
      {"Database: Opening and closing",      DatabaseIOSample,     "Dbio.c",
       IDS_DB_IO},
      {"Environment: Init & Connect",        InitEngSample,        "InitEng.c",
       IDS_INIT_ENG},
      {"Errors: Getting error info",         ErrVal,               "Errval.c",
       IDS_ERR_VAL},
      {"Table: Mapping and reading",         TBFieldMap,           "Fieldmap.c",
       IDS_FLD_MAP},
      {"Cursor: Filter (Basic)",             Filter,               "Filter.c",
       IDS_FILTER},
      {"Cursor: Filter (Comparison)",        FiltComp,             "FiltComp.c",
       IDS_FILTCOMP},
      {"Cursor: Filter (Continue)",          FiltCont,             "FiltCont.c",
       IDS_FILTCONT},
      {"Locking: Table",                     TblLock,              "TblLock.c",
       IDS_TBLLOCK},
      {"Locking: Directory",                 RdoLock,              "RdoLock.c",
       IDS_RDOLOCK},
      {"Locking: Record",                    RecLock,              "RecLock.c",
       IDS_RECLOCK},
      {"Query: Basic Example",               QBE,                  "QBE.c",
       IDS_QBE},
      {"Query: Join dBASE and PDOX",         QBE2,                 "QBE2.c",
       IDS_QBE2},
      {"Cursor: Ranges",                     Range,                "Range.c",
       IDS_RANGE},
      {"Session: Session I/O" ,              SessionIO,            "Session.c",
       IDS_SESSION_IO},
      {"Table: Sorting a table",             ParadoxSort,          "Prdxsort.c",
       IDS_SORT},
      {"Query: Local SQL - simple",          LocalSQL,             "LSQL.c",
       IDS_LOCALSQL},
      {"Query: Table join using SQL",        LocalSQLJoin,         "LSQLJoin.c",
       IDS_LOCALSQLJOIN},
      {"Query: SQL Parameter Binding",       SQLBind,              "Sqlbind.c",
       IDS_SQLBIND},
      {"Query: Using Stored Procedures",     StoredProcedures,     "StorProc.c",
       IDS_STORPROC},
      {"Query: Keyed Updates",               KeyUpdate,            "KeyUpdt.c",
       IDS_KEYUPDT},
      {"Query: Update ... Where current",    UpdateCurrent,        "Updtcrnt.c",
       IDS_UPDTCRNT},
      {"Environment: System Info",           SysInfo,              "SysInfo.c",
       IDS_SYSINFO},
      {"Table: Copying records",             BatchMove,            "BatMove.c",
       IDS_BATCH},
      {"Table: Create dBASE",                CreateAndFillSampleDB,"Cr8DbTbl.c",
       IDS_CR8DBTBL},
      {"Table: Create Paradox",              CreateAndFillSamplePX,"Cr8PxTbl.c",
       IDS_CR8PXTBL},
      {"Table: Create Text",                 CreateAndFillSampleTXT,"Cr8TxTbl.c",
       IDS_CR8TXTBL},
      {"Table: Getting table info",          TblInfo,              "TblInfo.c",
       IDS_TBLINFO},
      {"Cursor: Linking cursors",            LnkCrsr,              "LnkCrsr.c",
       IDS_LNKCRSR},
      {"Cursor: Navigating",                 Navigate,             "Navigate.c",
       IDS_NAVIGATE},
      {"Table: Password",                    Password,             "Password.c",
       IDS_PASSWORD},
      {"Table: Restructure",                 TBRestructure,        "Tbrstrct.c",
       IDS_RESTRUCTURE},
      {"Cursor: Search for key",             TableSearch,          "Search.c",
       IDS_SEARCH},
      {"Cursor: Soft delete",                SoftDel,              "SoftDel.c",
       IDS_SOFTDEL},
      {"Environment: Drivers",               DriverCaps,           "DrvCaps.c",
       IDS_DRVCAPS},
      {"Transactions: Creating",             SQLTran,              "Transact.c",
       IDS_SQLTRAN},
      {"Query: SQL DynaSet",                 LiveSQL,              "Lsqllive.c",
       IDS_LIVESQL},
      {"Table: Referential Integrity",       RefInteg,             "RefInteg.c",
       IDS_REFINTEG},
      {"Table: Validity Checks",             ValCheck,             "ValCheck.c",
       IDS_VALCHECK},
      {"Table: Password (Auxillary)",        SecDesc,              "SecDesc.c",
       IDS_SECDESC},
      {"Table: dBASE Security",              LoginCallback,        "DbLogin.c",
       IDS_LOGIN},
      {"Table: Tables with Missing files",   InputReqCallback,     "InputReq.c",
       IDS_INPUTREQ},
      {"Table: Optional Parameters",         OptParam,             "OptParam.c",
       IDS_OPTPARAM},
      {"Table: Open",                        TableOpen,            "TblOpen.c",
       IDS_TBLOPEN},
      {"Environment: Date and Time Format",  Format,               "Format.c",
       IDS_FORMAT},
      {"Record: Add, update, delete",        RecordUpdate,         "RecUpdat.c",
       IDS_RECUPDAT},
      {"Test: Framework for Testing",        Test,                 "Test.c",
       IDS_TEST},
      {"Table: Importing Text files",        TextImport,           "TextImp.c",
       IDS_TEXTIMP},
      {"Table: Exporting Text files",        TextExport,           "TextExp.c",
       IDS_TEXTEXP},
      {"Table: List",                        TableList,            "TblList.c",
       IDS_TBLLIST},
      {"Table: Create In-Memory",            CreateAndFillInMemoryTbl,"Inmemtbl.c",
       IDS_INMEMTBL},
      {"Session: CallBacks",                 TBRestructureCallBack,"Callback.c",
       IDS_CALLBACK},
      {"Environment: Language Drivers",      LangDriver,           "Langdrv.c",
       IDS_LANGDRV},
      {"Table: Upsizing",                    UpSize,               "Upsize.c",
       IDS_UPSIZE},
      {"",                                   NULL,                 "",
       (UINT16)-1},
};
